#!/bin/bash

set -e

SCRIPT_DIR="$( cd "$( dirname "${BASH_SOURCE[0]}" )" && pwd )"

IMAGE=mathcomp/mathcomp:1.15.0-coq-8.15

# Patch up permissions so the `coq` user in the container can write to
# the Prosa source tree.
PROSA="${SCRIPT_DIR}/../Prosa"
MARKER=".perms_updated_for_docker"
if [ ! -f "$PROSA/$MARKER" ]
then
    chmod -R ugo+w "$PROSA"
    touch "$PROSA/$MARKER"
fi
docker run --rm -v "${SCRIPT_DIR}/..":/rtss22 -w /rtss22 ${IMAGE} Docker/steps-in-Docker.sh
