#!/bin/bash

set -e

function note_step {
    echo
    echo
    echo '==============================================================================='
    echo "[$(date)] STEP $1:" $2
    echo '==============================================================================='
    echo
}

note_step 0 "Installing Prosa's Coq dependencies"

opam update
opam install -y -v coq-mathcomp-zify

note_step 1 "Compiling Prosa"

cd Prosa
bash create_makefile.sh --without-classic --without-refinements
make

note_step 2 "Verifying the Proofs"
make validate

note_step 3 "Generating the HTML Spec"
make htmlpretty

note_step 4 "All steps completed"

echo " => now please check the spec"

