#!/bin/bash

set -e

SCRIPT_DIR="$( cd "$( dirname "${BASH_SOURCE[0]}" )" && pwd )"

RTA="${SCRIPT_DIR}/rta-tool/target/release/rta-tool"
WORKLOADS="${SCRIPT_DIR}/workloads"

DONE_MARKER=.rta_done

function rta() {	
	$RTA -s FIFO --prefix results-FIFO- $*  &
	$RTA -s AFIFO --prefix results-AFIFO- $*  &
	$RTA -s FP --prefix results-FP- $*  &
	$RTA -s EDF --prefix results-EDF- $*  &
}

function run_exp {
	EX=$1

	if ! [ -e ${WORKLOADS}/ex${EX}/${DONE_MARKER} ]
	then
		echo "[II] Running experiment ${EX}..."
		for D in ${WORKLOADS}/ex${EX}/*
		do
			[ -d $D ] && rta $D/EX*.yaml
		done
		wait
		touch ${WORKLOADS}/ex${EX}/${DONE_MARKER}
	else
		echo "[II] Skipping experiment ${EX}; already done."	
	fi
}

run_exp 1
run_exp 2
run_exp 3
run_exp 4

echo "[II] Done with all experiments."
