# RTSS'22 Artifact Evaluation

This archive provides the research artifacts and reproducibility instructions for the paper entitled *From Intuition to Coq: A Case Study in Verified Response-Time Analysis of FIFO Scheduling* by Bedarkar et al., which is to appear at RTSS'22.

The paper is associated with two separate research artifacts:

1. The formal *Coq* development, based on the [Prosa framework](https://prosa.mpi-sws.org), which establishes the correctness of the presented response-time analysis (RTA) for FIFO scheduling. It constitutes the main case study presented in **Sections II-IV** of the paper.  

2. The empirical evaluation presented in **Section V** of the paper, which is primarily implemented in *Rust* (with some *Python* and *Bash* scripts).

As these two research artifacts are not connected at the implementation level and based on completely different tools and languages, we provide them in separate folders with individual instructions. 

## Top-Level Contents

1. `README.md` — this file. 
2. `README.html` — an HTML rendering of this file.
3. `paper.pdf` — a copy of the paper.
4. `1_Coq_Proof` — the first research artifact, namely the formal proof of correctness of the claimed response-time bound. 
5. `2_Evaluation` — the second research artifact, namely the implementation of the various response-time bounds in *Rust* and all code related to the experimental setup and evaluation. 

## Instructions

Please refer to the `README` files enclosed in the respective subfolders for further instructions and a description of the enclosed contents. 

